//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//    

int linkstcp_vsnd(const unsigned char* oline,int tcp) {
	int SBUF = lt[tcp]->linesize;
	if (lt[tcp]->socketunselected == 1) {return;}
	if (strlen(oline) >= SBUF) {printf("<<LINKFAIL[%d] %s\n",tcp,oline);return -1;}//too big; this is not allowed
	unsigned char line[SBUF]; // TODO: fix tcc support
	strncpy(line,oline,SBUF-1);line[SBUF-1] = 0;
	if (strlen(line) <= 0) {return -1;}
	if (line[strlen(line)-1] != '\n') {
		if (strlen(line) < SBUF - 2) {
			strcat(line,"\r\n");
		}else{
			return -1;
		}
	}
#ifdef ACTIVATEDEBUG
	if (strstw(oline,"ping ") == false && strstw(oline,"pong ") == false) {
		printf("<<LINK[%d] %s",tcp,oline);
	}
#endif
	int r = 0;
	int k;
	while (r < LINKSENDBUFFERS) {
		if (lt[tcp]->sendbuffer[r] == NULL) {
			break;
		}
		r += 1;
	}
	if (r == 0) {//nothing allocated yet; allocate
		lt[tcp]->sendbuffer[r] = malloc(SBUF);
		strcpy(lt[tcp]->sendbuffer[r],line);
		lt[tcp]->sendblocks++;
		wantsend++;
		return 0;
	}else{
		if (strlen(lt[tcp]->sendbuffer[r - 1]) + strlen(line) < SBUF) {
			strcat(lt[tcp]->sendbuffer[r - 1],line);
			return 0;
		}else{
			if (r >= LINKSENDBUFFERS - 1) {
				//lt[tcp]->needquit = 1;
				return -1;
			}//all pointers used; full!
			if (strlen(lt[tcp]->sendbuffer[r - 1]) >= SBUF - 1) {
				lt[tcp]->sendbuffer[r] = malloc(SBUF);
				strcpy(lt[tcp]->sendbuffer[r],line);
				lt[tcp]->sendblocks++;
				wantsend++;
				return 0;
			}else{
				k = SBUF - (strlen(lt[tcp]->sendbuffer[r - 1]) + 1);
				strncat(lt[tcp]->sendbuffer[r - 1],line,(SBUF - 1)-strlen(lt[tcp]->sendbuffer[r-1]));
				lt[tcp]->sendbuffer[r-1][SBUF - 1] = 0;
				cut(line,k);
				lt[tcp]->sendbuffer[r] = malloc(SBUF);
				strcpy(lt[tcp]->sendbuffer[r],line);
				lt[tcp]->sendblocks++;
				wantsend++;
				return 0;
			}
		}
	}
}
void linkstcp_scrollSendBuffer(int tcp) {
	int r = 0;
	if (lt[tcp]->sendbuffer[0] != NULL) {free(lt[tcp]->sendbuffer[0]);}
	while (r < LINKSENDBUFFERS - 1) {
		lt[tcp]->sendbuffer[r] = lt[tcp]->sendbuffer[r + 1];
		r += 1;
	}
	lt[tcp]->sendbuffer[LINKSENDBUFFERS - 1] = NULL;
	lt[tcp]->sendblocks--;
	wantsend--;
}

int linkstcp_sendOnSocket(int id,const unsigned char* buffer,int buffsize) {
	errno = 0;
	if (lt[id]->socketunselected == 1) {return;}
	if (!FD_ISSET(lt[id]->socket,wcpy)) {return;}
	int retval = send(lt[id]->socket,buffer,buffsize,0);//MSG_NOSIGNAL);
	if (retval > 0) {
		lt[id]->somethingsent = 1;
		return retval;
	}else{
#ifdef WIN
		int err = WSAGetLastError();
		if ((err != WSAEWOULDBLOCK && err != WSAEINTR && err != WSAENOBUFS) || retval == 0) {
#endif
#ifndef WIN
		if ((errno != EWOULDBLOCK && errno != EINTR && errno != ENOBUFS) || retval == 0) {
#endif
			if (lt[id]->socketunselected == 0) {
				lt[id]->socketunselected = 1;
				FD_CLR(lt[id]->socket,&socketset);
				recalculatenfds();
				wantsend -= lt[id]->sendblocks;
			}
			linkstcp[id]->needquit = 1;
			return -1;
		}else{
			return 0;
		}
	}
}
void linkstcp_sendstuff(int id) {
	int k;
	if (lt[id]->socketunselected == 1) {return;}
	if (!FD_ISSET(lt[id]->socket,wcpy)) {return;}
	if (lt[id]->sendbuffer[0] != NULL) {
		k = linkstcp_sendOnSocket(id,lt[id]->sendbuffer[0],strlen(lt[id]->sendbuffer[0]));
		if (k == strlen(lt[id]->sendbuffer[0])) {
			linkstcp_scrollSendBuffer(id);
		}else{
			if (k < 0) {return;}//something went wrong
			if (k > 0) {cut(lt[id]->sendbuffer[0],k);}
		}
	}
}
void linkstcp_sendAll() {
	int i = 0;
	while (i < MAXLINKS) {
		if (lt[i] != NULL) {
			if (lt[i]->needquit == 0 && lt[i]->socketunselected == 0) {
				if (lt[i]->type == LINKTYPE_ACTIVE) {
					if (lt[i]->connecting != 1) {//must be 2 or 0
						linkstcp_sendstuff(i);
					}
				}
				if (lt[i]->type == LINKTYPE_PASSIVE) {
					linkstcp_sendstuff(i);
				}
			}
		}
		i += 1;
	}
}
void linkstcp_clientcheck(int id) {
	int addrlen = sizeof (struct sockaddr_in);
	struct sockaddr_in address;
	int new_socket,r;
	if (!FD_ISSET(lt[id]->socket,cpy)) {return;}
	new_socket = accept(lt[id]->socket,(struct sockaddr *) &address,&addrlen);
	if (new_socket > 0) {
		setSocketNonblocking(new_socket);
		int new = newpassiveconnection(id, inet_ntoa (address.sin_addr));
		if (new >= 0) {
			int tcpid = linkstcp_getPassiveTcp(new);
			if (tcpid >= 0) {
				lt[tcpid]->socket = new_socket;
				plinks[new]->socket = new_socket;
				FD_SET(new_socket,&socketset);
				recalculatenfds();
				setSocketNonblocking(plinks[new]->socket);
				plinks[new]->connecttime = ts();
			}
		}else{
			close(new_socket);//it failed, throw it away
		}
	}
}
void linktcp_check() {
	int r = 0;
	while (r < MAXLINKS) {
		if (lt[r] != NULL) {
			if (lt[r]->type == LINKTYPE_LISTENER) {
				linkstcp_clientcheck(r);
			}
		}
		r++;
	}
}

